main()
{
	maps\mp\_load::main();
	

	//level settings
	setCullFog (0, 18000, .8, .8, .8, 0);
	
	game["allies"] = "american";
	game["axis"] = "german";
	game["american_soldiertype"] = "airborne";
	game["american_soldiervariation"] = "normal";
	game["german_soldiertype"] = "kriegsmarine";
	game["german_soldiervariation"] = "normal";


	//variables
	level.radioChannels = 4;
	level.currentRadioChannel = 0;
	level.loopRadio = false;
	level.musicenabled = false;

	
	//threads
	thread playRadio();
	thread secretRadio();
	thread finishMessage();


}

/*
* Playing music from the radio
*/
playRadio(){
	radio = getent("radio", "targetname");	
	
	while(1){
		radio thread radioTrigger("radioTrigger1");
		radio thread radioTrigger("radioTrigger2");
		radio thread radioTrigger("radioTrigger3");
		radio thread radioTrigger("radioTrigger4");
		radio thread radioTrigger("radioTrigger5");
		radio waittill("channelChanged", user);		
		level.loopRadio = false;
		
		if(level.currentRadioChannel < level.radioChannels){
			level.currentRadioChannel++;
		} 
		else{
			level.currentRadioChannel = 0;
		}
		//changed "radio playsound" to "user playlocalsound"
		switch(level.currentRadioChannel){
			case 0:
				user iPrintLn("Radio off");
				user playlocalsound("Silent");
				wait(1.1);
				break;
			case 1:		
				user playlocalsound("RadioStatic");
				wait(1.1);
				user iPrintLn("^6P^7haxe & Morten Granau - Beatless");
				user playlocalsound("beatless");
				level.loopRadio = true;
				thread loopSound("beatless", 251, user, "radio", 1, true);
				wait(1.1);
				break;
			case 2:
				user playlocalsound("RadioStatic");
				wait(1.1);
				user iPrintLn("^6N^7ick Scofield - Free Love");
				user playlocalsound("freeLove");
				level.loopRadio = true;
				thread loopSound("freeLove", 467, user, "radio", 1, true);
				wait(1.1);
				break;
			case 3:
				user playlocalsound("RadioStatic");
				wait(1.1);
				user iPrintLn("^6J^7onas Mantey - Frei");
				user playlocalsound("frei");
				level.loopRadio = true;
				thread loopSound("frei", 244, user, "radio", 1, true);	
				wait(1.1);
				break;
			default:				
				user playlocalsound("Silent");
				break;
		}
	}
}

/*
* Enable support to trigger the radio from multiple triggers - the radio entity must call this
*/
radioTrigger(radioTriggerName){
	radioTrigger = getent(radioTriggerName, "targetname");
	while(1){
		radioTrigger waittill("trigger", user);
		self notify("channelChanged", user);
	}
}

/*
* sound that arent played from "ambientplay" cant be set "looped" in the .csv file? wtf
* My own looping function for various entities
* param soundName: the sound that will be played
* param soundTime: the sound will start playing again after waitTime has occured soundTime times. ex: soundTime = 10 and waitTime = 0.5 => the loop will continue for 10 iterations with 0.5s in each loop, so the sound will play again in 5 seconds
* param loopingVariable: for indicating which variable should be chosen to determine if its looping
* param entity: the entity that will be playing this sound, also specifies the continuelooping variable later on
* param waitTime: the to wait in each 'while' loop. If u want to stop the loop make sure that the time continueLooping is set to false >= waitTime
* param isLocalSound: true for sounds that are played locally from a player, like this only thep layer will hear the sound
*/
loopSound(soundName, soundTime, entity, loopingVariable, waitTime, isLocalSound){	
	i = 0;
	continueLooping = true;
	
	while(continueLooping){	
		//Check wheter the looping must stop or not by linking global variables
		//ContinueLooping cant be a local parameter for this to work -> use switch for global variable
		switch(loopingVariable){
			case "radio": continueLooping = level.loopRadio;
					break;
			case "clubMusicPlayer": continueLooping =  true;
					break;
			default:
					continueLooping = true;
					break;
		}	
		wait(waitTime);
		if(i >= soundTime){
			if(!isLocalSound){entity playsound(soundName);} 
			else{entity playlocalsound(soundName);}
			i = 0;
		}
		else{
			i++;
		}	
	}
}


secretRadio(){
	
	musicTrigger = getent("musicTrigger", "targetname");
	
	while(1){
		musicTrigger waittill("trigger", user);
		ambientStop();
		user playlocalsound("Silent");
		ambientPlay("walkingInTheAir");
		wait(0.05);
		wait 25;
		iPrintLnBold( "^5We're walking in the aiiiir" );
		wait 8;
		iPrintLnBold( "^5We're floating in the morning skyyyy" );
		wait 120;
		ambientStop();
	}		
}


finishMessage()
{
	t = getent("finished","targetname");
		
	while(1)
	{
		t waittill("trigger", user);
		if(!isDefined(user.hasFinishedNeon))
			user.hasFinishedNeon = false;
			
		if(!user.hasFinishedHeaven)
		{
			user.hasFinishedHeaven = true;
			iprintlnbold("Well done, "+user.name+"^7 has finished the map!");
			user iprintlnbold("Well done "+user.name+"^7, you've finished gg_neon_v3");
			wait 3;
			user iprintlnbold("Thank ^6you ^7for ^6playing ^7!!! ^6Now ^7try ^6the ^7other ^6side ^7!!! ^6!!!");
			wait 2;
			user iprintlnbold("^6< ^7 3 ^6<^7 3 ^6< ^7 3 ^6<^7 3 ^6< ^7 3 ^6<^7 3 ^6< ^7 3 ^6<^7 3 ^6< ^7 3 ^6<^7 3 ^6< ^7 3 ^6<^7 3");
			wait 2;
			user iprintlnbold("^6 TheGoog ^7kisses you ^6:* :* :* ^7<3");
		}
	}
}